<template>
  <div class="questionnaire-container">
    <ObQuestionnaire
      :groups="questionnaireValue"
      :fields-disabled="fieldsDisabled"
      :is-add-user-questions="isUserQuestionsEnabled"
      :passing-score="passingScore"
      :show-add-button="!fieldsDisabled"
      @add="onAdd"
      @weight-changed="onWeightChanged"
      @user-question-modified="modifyUserQuestion"
      @user-question-blur="submitUserQuestions"
      @delete-group="deleteGroup"
      @delete-question="deleteQuestion"
      @passing-score-status-changed="onPassingScoreStatusChanged"
      @passing-score-changed="onPassingScoreChanged"
      class="questionnaire"
    >
      <template slot="noneContent">
        <div class="none-content">
          <div class="none-content__title">
            Здесь еще нет ни одной записи.<br>
            Добавляйте разделы целиком или отдельные вопросы
          </div>

          <ObButton
            type="flat"
            label="Добавить раздел или вопрос"
            @click="openAddModal"
          />
        </div>
      </template>

      <template slot="extraFuncToPanel">
        <ObMenuDropdown
          :items="excelDropdownItems"
          icon="excel"
        />
      </template>
    </ObQuestionnaire>

    <ObModal
      ref="addQuestionnaire"
      title="Вопросы для RFI анкеты"
      ok-text="Добавить"
      size="extra-large"
      data-qa="questionnaireModal"
    >
      <AddQuestionnaire
        @add="submitQuestions"
        :questions="allAvailableQuestions"
        :static-groups="staticGroups"
        :is-user-questions-enabled="isUserQuestionsEnabled"
        :modal-state="isAddQuestionsModalVisible"
      />
    </ObModal>

    <SuccessExport
      ref="successExportModal"
      :data-source="exportResult"
    />
  </div>
</template>

<script>
  import ObQuestionnaire from 'common-components/src/obComponents/obQuestionnaire'
  import ObModal from 'common-components/src/obComponents/obModal'
  import ObButton from 'common-components/src/obComponents/obButton'
  import AddQuestionnaire from './modal/addQuestionnaire'
  import QuestionnaireLoading from '../mixins/questionnaire-loading'
  import { mapGetters, mapActions } from 'vuex'
  import api from '@/api'
  import ExportExcel from '../mixins/export-excel'

  export default {
    name: 'tender-tab-buyer-questionnaire',
    components: {
      ObQuestionnaire,
      ObModal,
      ObButton,
      AddQuestionnaire
    },
    mixins: [
      QuestionnaireLoading,
      ExportExcel
    ],
    computed: {
      ...mapGetters({
        tenderInfo: 'tenders/tenderInfo',
        tenderFormDataChanged: 'tenders/tenderFormDataChanged',
        currentRole: 'tenders/currentRole'
      })
    },
    data () {
      return {
        fieldsDisabled: false,
        isUserQuestionsEnabled: false,
        isAddQuestionsModalVisible: false,
        questions: [],
        allAvailableQuestions: [],
        passingScore: null,
        userQuestionsGroupUuid: null,
        staticGroups: [],
        userQuestionsChanges: {
          added: [],
          modified: [],
          deleted: []
        }
      }
    },
    async mounted () {
      this.fieldsDisabled = await this.tenderInfo.status !== 'DRAFT'
      this.passingScore = await this.tenderInfo.minWeightSum

      // Using to reinitialize 'Add questions' modal checked rows
      this.$watch('$refs.addQuestionnaire.visible', (isVisible) => {
        this.isAddQuestionsModalVisible = isVisible
      })
    },
    methods: {
      ...mapActions({
        updateTenderQuestionnaire: 'tenders/updateTenderQuestionnaire',
        getTender: 'tenders/getTender'
      }),
      async openAddModal () {
        await this.fetchQuestions()

        this.$refs.addQuestionnaire.open()
      },
      onAdd () {
        this.openAddModal()
      },
      /* QUESTION */
      async fetchQuestions () {
        const res = await api.tenders.getQuestionnaireSettings(this.tenderInfo.questionnaireUuid)

        res.questionGroups.sort((a, b) => {
          return a.pos - b.pos
        })

        this.allAvailableQuestions = res.questionGroups.reduce((arr, group) => {
          if (group.isUserQuestionsAvailable) {
            // Saving user question group uuid to remove this uuid before saving settings,
            // because user questions group uuid isn't a question uuid, so it cannot be saved
            this.userQuestionsGroupUuid = group.uuid
            this.staticGroups = [group.title]

            if (group.questions) {
              // Added new property to detect user questions in 'Add' modal
              group.questions.forEach(question => question.isUserQuestion = true)
            } else {
              // If user questions groups don't have any question,
              // using this group as question, because otherwise
              // ObTable can't showing it (due to :group-by property)
              group.group = group.title

              return arr.concat(group)
            }
          }

          group.questions.map((question) => {
            question.group = group.title

            switch (question.type) {
              case 'TEXT':
                question.typeReadable = 'Текст'
                break

              case 'SELECT':
                question.typeReadable = 'Выбор варианта'
                break

              case 'MULTISELECT':
                question.typeReadable = 'Множественный выбор'
                break
            }

            return question
          })

          return arr.concat(group.questions.sort((a, b) => {
            return a.pos - b.pos
          }))
        }, [])
      },
      async submitQuestions (questions, isUserQuestionsEnabled, isReload = true) {
        try {
          // Saving user questions group state - it's using
          // if there is no one user questions and we need to
          // manually draw the first blank user question in ObQuestionnaire
          this.isUserQuestionsEnabled = isUserQuestionsEnabled

          if (!this.isUserQuestionsEnabled) {
            await this.deleteAllUserQuestions()
          }

          await api.tenders.updateQuestionnaireSettings(this.tenderInfo.questionnaireUuid, {
            // Removing user questions group uuid, because it cannot be saved on backend
            questions: questions.filter(uuid => uuid !== this.userQuestionsGroupUuid)
          })

          if (isReload) {
            await this.getQuestionnaire()
          }

          this.$refs.addQuestionnaire.close()
          this.updateTenderQuestionnaire()

          this.$notification({
            type: 'snackbars',
            message: 'Анкета успешно обновлена'
          })
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка сохранения анкеты'
          })
        }
      },
      async submitUserQuestions (isUpdateTender = true) {
        let isChangesFound = false

        const data = Object.entries(this.userQuestionsChanges).reduce((data, questions) => {
          data[questions[0]] = {
            questions: questions[1],
            groupUuid: this.userQuestionsGroupUuid
          }

          // Flush arrays to prevent sending duplicates
          this.userQuestionsChanges[questions[0]] = []

          if (questions[1].length) {
            isChangesFound = true
          }

          return data
        }, {})

        if (!isChangesFound) {
          return
        }

        if (data.modified.questions.length) {
          await api.tenders.modifyQuestionnaireUserQuestions(this.tenderInfo.questionnaireUuid, data.modified)
        }

        if (data.deleted.questions.length) {
          await api.tenders.deleteQuestionnaireUserQuestions(this.tenderInfo.questionnaireUuid, data.deleted)
        }

        if (data.added.questions.length) {
          await api.tenders.addQuestionnaireUserQuestions(this.tenderInfo.questionnaireUuid, data.added)

          // To reload 'questions' array to get information, which
          // question is new and which question is modified
          this.storeQuestions()
        }

        if (isUpdateTender) {
          this.updateTenderQuestionnaire()
        }
      },
      modifyUserQuestion (uuid, title) {
        let question

        // Don't processing question with empty title
        if (!title) {
          return
        }

        // If this question was exists in questionnaire before modifying
        if (this.questions.find(question => question.uuid === uuid)) {
          question = this.userQuestionsChanges.modified.find(question => question.uuid === uuid)

          // This question hasn't been modified yet
          if (!question) {
            this.userQuestionsChanges.modified.push({ uuid, title })

            return
          }
        } else {
          question = this.userQuestionsChanges.added.find(question => question.uuid === uuid)

          // Question was created, but modified first time,
          // this logic works because we cannot create questions
          // without title, so title will be available only after
          // question modification
          if (!question) {
            this.userQuestionsChanges.added.push({ uuid, title })

            return
          }
        }

        question.title = title
      },
      async deleteGroup (uuid, isUserGroup) {
        if (isUserGroup) {
          this.isUserQuestionsEnabled = false

          const userQuestionsGroup = this.questionnaireValue.find(group => group.isUserQuestionsAvailable)

          // If user group was added to questionnaire on backend (it can be empty)
          if (userQuestionsGroup) {
            // Need to delete all existing user questions
            await this.deleteAllUserQuestions()
          }
        }

        this.questionnaireValue = this.questionnaireValue.filter(group => group.uuid !== uuid)

        this.storeQuestions()

        await this.submitQuestions(this.questions.map(question => question.uuid), this.isUserQuestionsEnabled, false)
      },
      async deleteQuestion (uuid, isUserQuestion) {
        this.questionnaireValue = this.questionnaireValue.reduce((result, group) => {
          const data = {
            ...group,
            questions: group.questions.filter(question => question.uuid !== uuid)
          }

          if (data.questions.length) {
            result.push(data)
          } else if (isUserQuestion) {
            this.isUserQuestionsEnabled = false
          }

          return result
        }, [])

        if (isUserQuestion) {
          if (this.questions.find(question => question.uuid === uuid)) {
            // If this question was exists in questionnaire before deleting
            this.userQuestionsChanges.deleted.push(uuid)

            await this.submitUserQuestions()
            this.storeQuestions()
          } else {
            // If it's a new user question, and it's didn't saved to the backend
            const index = this.userQuestionsChanges.added.findIndex(question => question.uuid === uuid)

            this.userQuestionsChanges.added.splice(index, 1)
          }

          // To user group is empty
          if (!this.questions.find(question => question.isUserQuestion)) {
            this.isUserQuestionsEnabled = false

            // To delete empty user group
            await this.getQuestionnaire()
          }
        } else {
          this.storeQuestions()

          await this.submitQuestions(this.questions.reduce((questions, question) => {
            // Don't send new user questions
            if (!(question.isUserQuestion && !question.value)) {
              questions.push(question.uuid)
            }

            return questions
          }, []), this.isUserQuestionsEnabled, false)
        }
      },
      async deleteAllUserQuestions () {
        const userQuestionsGroup = this.questionnaireValue.find(group => group.isUserQuestionsAvailable)

        userQuestionsGroup?.questions.forEach(question => this.userQuestionsChanges.deleted.push(question.uuid))

        await this.submitUserQuestions(false)
      },
      storeQuestions () {
        // Store all question to the separate variable
        // to check new questions in 'userQuestionsChanges' variable
        this.questions = this.questionnaireValue.reduce((questions, group) => questions.concat(group.questions), [])
      },
      /* PASSING SCORE */
      async onPassingScoreStatusChanged (inEnabled) {
        await this.onPassingScoreChanged(inEnabled ? 0 : null)
      },
      async onPassingScoreChanged (score) {
        this.passingScore = score

        try {
          await api.tenders.updateQuestionnaireWeights(this.tenderInfo.questionnaireUuid, {
            minWeightSum: score,
            questions: []
          })

          await this.getTender({
            type: this.tenderInfo.type,
            uuid: this.tenderInfo.uuid
          })

          let message

          switch (score) {
            case null:
              message = 'Проходной балл выключен'
              break

            case 0:
              message = 'Проходной балл включен'
              break

            default:
              message = 'Проходной балл успешно изменён'
              break
          }

          this.$notification({
            type: 'snackbars',
            message
          })
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка изменения проходного балла'
          })
        }
      },
      /* OTHER */
      async onWeightChanged (question) {
        try {
          await api.tenders.updateQuestionnaireWeights(this.tenderInfo.questionnaireUuid, {
            minWeightSum: this.passingScore,
            questions: [{
              uuid: question.uuid,
              fields: question.fields.map(({ uuid, weight }) => {
                return { uuid, weight }
              })
            }]
          })
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка изменения анкеты'
          })
        }
      },
      async exportToExcel () {
        this.exportResult = await api.tendersExcels.RFIQuestionnaire(this.tenderInfo.questionnaireUuid)
      }
    }
  };
</script>

<style lang="scss" scoped>
  @import '~common-components/src/assets/style/ob-style';

  .questionnaire-container {
    height: 100%;
    padding: 0 20px 20px;
  }

  .questionnaire {
    height: 100%;
    display: flex;
    flex-direction: column;
  }

  .none-content {
    height: 100%;
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: center;
    text-align: center;

    &__title {
      font-size: 24px;
      line-height: 29px;
      color: $color-grey-span;
      margin-bottom: 20px;
    }
  }
</style>
